/**@file stack.c
 * @brief Balanced parentheses
 *
 * Reads in a text stream from standard input and uses a stack to determine 
 * whether its parentheses are properly balanced. For example, your program 
 * should print true for [()]{}{[()()]()} and false for [(]). 
 *
 * @author Pavlos Antoniou
 * @bug No known bugs
 */
#include "stack.h"
 
STACK *initStack(){
  STACK *stack = (STACK *) malloc(sizeof(STACK));
  if (stack == NULL) return NULL;
  stack->top = NULL;
  stack->size = 0;
  return stack;
}

int push(STACK *stack, int value) {
  NODE *p = NULL;
  
  p = (NODE *)malloc(sizeof(NODE));
  if(p==NULL) {
    printf("System out of memory!\n");
    exit(EXIT_FAILURE);
  }
  
  p->data = value;
  p->next = stack->top;
  stack->top = p;
  (stack->size)++;
  
  return EXIT_SUCCESS;
}


int pop(STACK *stack, int *retval) {
  
  NODE *p = NULL;
  
  if ( stack == NULL || stack->size == 0 ) {
    printf("Sorry, stack is empty…\n");
    return EXIT_FAILURE;
  }
  
  *retval = stack->top->data;
  p = stack->top;
  stack->top = p->next;
  (stack->size)--;
  
  free(p);
  return EXIT_SUCCESS;       
}

/*void clear(stack **p) {
  stack *tmp;
  while(*p) {
  tmp = (*p)->prev;
  free(*p);
  *p = tmp;
  }
  }*/

/*void display(STACK *stack) {
  NODE tmp = stack->top;
  
  while(tmp) {
  printf("%d\n",temp->data);
  temp = temp->next;
  }
  }
*/
/*************************************************************************/


