#ifndef STACK_H
#define STACK_H
// A) Libraries
#include "def.h"

// B) Declarations
/*
 * The stack structure
 */
typedef struct {
  NODE *top;
  int size;
} STACK;

// C) Function Prototypes
/**
* Doxygen Comment 
*/
STACK *initStack();

/* Comments */
bool IsEmptyStack(STACK *stack);

/** @brief Displays the stack
 *
 * @param stack* the stack
 * @return void
 */
void display(STACK *stack);

/** @brief Returns the item on the top of the stack
 *
 * @param stack* the stack
 * @return 
 */ 
void top(STACK *stack);

/** @brief Push an element to the stack
 *
 * @param stack* the stack
 * @param value the element
 * @return 
 */
int push(STACK *stack, int value);

/** @brief Pop value from the stack
 *
 * @param stack* the stack
 * @param retval* the element popped from stack
 * @return
 */
int pop(STACK *stack, int *retval); 

/** @brief Clear the stack
 *
 * Deletes the elements of the stack. Free the memory.
 *
 * @param stack** the stack
 * @return void
 */
void clear(STACK *stack);
#endif
