/** @file infixTOpostfix.c
 * @brief Converting from infix to postfix.
 *
 * Read in the tokens one at a time. If it is an operator, push it on the stack;
 * if it is an integer, print it out; if it is a right parentheses, pop the 
 * topmost element from the stack and print it out; if it is a left parentheses,
 * ignore it.  
 *
 * @author Pavlos Antoniou
 * @bug No known bugs
 */
 
#include "stack.h"

int main (int argc, char **argv) {

  char c;

  char PLUS     = '+';
  char MINUS    = '-';
  char TIMES    = '*';
  char DIVIS    = '/';

  stack *parStack;
  parStack = NULL;

  printf("Enter an infix expression : ");

  while ((c = getchar()) != '\n') {

    if (c == PLUS)
      push(&parStack, c);
    else 
      if (c == TIMES) 
	push(&parStack, c);
      else 
	if (c == MINUS) 
	  push(&parStack, c);
	else
	  if (c == DIVIS) 
	    push(&parStack, c);
	  else
	    if (c == ')') 
	      printf("%c ", pop(&parStack)); 
	    else
	      if (c == '(') 
		printf("");
	      else  
		printf("%c ", c);
  }
  printf("\n");
  
  return 0;

}

