/** @file parentheses.c
 * @brief Check for balanced parenthesis
 *
 * Reads in a text stream from standard input and uses a stack to determine 
 * whether its parentheses are properly balanced. For example, your program 
 * should print true for [()]{}{[()()]()} and false for [(]). 
 *
 * @author Pavlos Antoniou
 * @bug No known bugs
 */
 
#include "stack.h"



int main (int argc, char **argv) {

  int i;
  char c;

  char L_PAREN    = '(';
  char R_PAREN    = ')';
  char L_BRACE    = '{';
  char R_BRACE    = '}';
  char L_BRACKET  = '[';
  char R_BRACKET  = ']';

  stack *parStack ;
  parStack = NULL;

  printf("Enter a string: ");

  while ((c = getchar()) != '\n') {
    if (c == L_PAREN)
      push(&parStack, L_PAREN);
    else 
      if (c == L_BRACE)
	push(&parStack, L_BRACE);
      else 
	if (c == L_BRACKET) 
	  push(&parStack, L_BRACKET);
	else 
	  if (c == R_PAREN) {
	    if (!length(parStack)) {
	      //return false;
	      printf("Parentheses not balanced RP\n");
	      return 0;
	    }
	    if (pop(&parStack) != L_PAREN) {
	      //return false;
	      printf("Parentheses not balanced LP\n");
	      return 0;
	    }
	  }
	  else 
	    if (c == R_BRACE) {
	      if (!length(parStack)) {
		//return false;
		printf("Parentheses not balanced RB\n");
		return 0;
	      }
	      if (pop(&parStack) != L_BRACE) {
		//return false;
		printf("Parentheses not balanced LB\n");
		return 0;
	      }
            }
            else 
	      if (c == R_BRACKET) {
                if (!length(parStack)){
		  //return false;
		  printf("Parentheses not balanced RBR\n");
		  return 0;
		}
                if (pop(&parStack) != L_BRACKET) {
		  //return false;
		  printf("Parentheses not balanced LBR\n");
		  return 0;
		}
	      }   
  }
  if (!length(parStack))
    printf("Parentheses are balanced\n");
  else
    printf("Parentheses not balanced\n");

  return 0;

}

