#include "stack.h"


void push(stack **p, int val) {
  stack *element = (stack *)malloc(sizeof(stack));
  if(!element) 
    exit(EXIT_FAILURE);   
  
  element->value = val;
  element->prev = *p;
  *p = element;       
}


int pop(stack **p) {
  int val;
  stack *tmp;
  if(!*p) return -1;     /* Retourne -1 si la stack est vide. */
  tmp = (*p)->prev;
  val = (*p)->value;
  free(*p);
  *p = tmp;       /* Le pointeur pointe sur le dernier élément. */
  return val;     /* Retourne la value soutirée de la stack. */
}


void clear(stack **p) {
  stack *tmp;
  while(*p) {
    tmp = (*p)->prev;
    free(*p);
    *p = tmp;
  }
}


int length(stack *p) {
  int n=0;
  while(p) {
    n++;
    p = p->prev;
  }
  return n;
}


void display(stack *p) {
  while(p) {
    printf("%d\n",p->value);
    p = p->prev;
  }
}

