#ifndef __STACK_H__
#define __STACK_H__

#include <stdio.h>
#include <stdlib.h>

/*
 * The stack structure
 * Attention: The stack is implemented using one struct and not two as in 
 * Lecture 10.
 */
typedef struct stack {
  int value;
  struct stack *prev;
} stack ;


/** @brief Push an element to the stack
 *
 * @param stack** the stack
 * @param int the element
 * @return void
 */
void push(stack **, int);


/** @brief Pop value from the stack
 *
 * @param stack** the stack
 * @return int the element popped from stack
 */
int pop(stack **);


/** @brief Clear the stack
 *
 * Deletes the elements of the stack. Free the memory.
 *
 * @param stack** the stack
 * @return void
 */
void clear(stack **);


/** @brief Returns the number of elements in the stack
 *
 * @param stack* the stack
 * @return int number of elements
 */
int length(stack *p);


/** @brief Displays the stack
 *
 * @param stack* the stack
 * @return void
 */
void display(stack *);
           
#endif
